Unit Buttons;

Interface

Const
     CPanel     = #00#$0F#08#07;
     CStatusBar = #00#$0F#08#07#09#$0F;
     CTextButton= #00#$0F#08#07#01;

     pbPress    = True;
     pbUnPress  = False;

Type
    PString=^String;

    PPalette=^String;

    PPanel=^TPanel;
    TPanel=Object
           Cnvx:Integer;
           X, Y, Wdth, Hght:Word;
           Constructor Init(AX1, AY1, AWdth, AHght:Word; ACnvx:Integer);
           Destructor Done; Virtual;
           Procedure Show; Virtual;
           Function GetColor(I:Word):Byte; Virtual;
           Function GetPalette:PPalette; Virtual;
    End;

    PStatusBar=^TStatusBar;
    TStatusBar=Object(TPanel)
           Prcnt:Longint;
           Constructor Init(AX1, AY1, AWdth, AHght:Word; ACnvx:Integer);
           Procedure Show; Virtual;
           Function GetString:String; Virtual;
           Function GetPercent:Word; Virtual;
           Function GetPalette:PPalette; Virtual;
           Procedure SetPercent(APrcnt:Longint);
    End;

    PButton=^TButton;
    TButton=Object(TPanel)
          Constructor Init(AX1, AY1, AWdth, AHght:Word; ABHght:Integer);
          Procedure Show; Virtual;
          Procedure ShowButtonImage(IX, IY:Word); Virtual;
          Procedure Press(APrss:Boolean); Virtual;
          Function GetPressed:Boolean;
    End;

    PTextButton=^TTextButton;
    TTextButton=Object(TButton)
         Title:PString;
         Constructor Init(AX1, AY1, AWdth, AHght:Word; ABHght:Integer;
                          Const ATitle:String);
         Destructor Done; Virtual;
         Procedure ShowButtonImage(IX, IY:Word); Virtual;
         Function GetPalette:PPalette; Virtual;
    End;

Function NewStr(Const S:String):PString;
Procedure DisposeStr(Var P:PString);

Implementation

Uses Graph;

Constructor TPanel.Init(AX1, AY1, AWdth, AHght:Word; ACnvx:Integer);
Begin
  X:=AX1; Y:=AY1; Wdth:=AWdth; Hght:=AHght;
  Cnvx:=ACnvx;
End;

Destructor TPanel.Done;
Begin
End;

Procedure TPanel.Show;
Var C:Byte;
    I:Integer;
    FS:FillSettingsType;
Begin
  C:=Graph.GetColor;
  SetColor(GetColor(1));
  MoveTo(X+1, Y); LineRel(Wdth-2, 0);
  MoveRel( 1,  1); LineRel(0, Hght-2);
  MoveRel(-1,  1); LineRel(-(Wdth-2), 0);
  MoveRel(-1, -1); LineRel(0, -(Hght-2));
  If Cnvx>0 Then SetColor(GetColor(2)) Else SetColor(GetColor(3));
  For I:=1 To Abs(Cnvx) Do
      Begin
        MoveTo(X+I, Y+I); LineRel(Wdth-(I+1), 0);
        MoveTo(X+I, Y+I); LineRel(0, Hght-(I+1));
      End;
  If Cnvx>0 Then SetColor(GetColor(3)) Else SetColor(GetColor(2));
  For I:=1 To Abs(Cnvx) Do
      Begin
        MoveTo(X+Wdth-I, Y+Hght-I); LineRel(-(Wdth-2*(I+1)), 0);
        MoveTo(X+Wdth-I, Y+Hght-I); LineRel(0, -(Hght-2*(I+1)));
      End;
  GetFillSettings(FS);
  SetFillStyle(SolidFill, GetColor(4));
  Bar(X+Abs(Cnvx)+1, Y+Abs(Cnvx)+1, X+Wdth-Abs(Cnvx), Y+Hght-Abs(Cnvx));
  SetFillStyle(FS.Pattern, FS.Color);
  SetColor(C);
End;

Function TPanel.GetColor(I:Word):Byte;
Begin
  GetColor:=Byte(GetPalette^[I]);
End;

Function TPanel.GetPalette:PPalette;
Const P:String[Length(CPanel)]=CPanel;
Begin
  GetPalette:=@P;
End;

Constructor TStatusBar.Init(AX1, AY1, AWdth, AHght:Word; ACnvx:Integer);
Begin
  Inherited Init(AX1, AY1, AWdth, AHght, ACnvx);
  Prcnt:=0;
End;

Procedure TStatusBar.Show;
Var S:String;
    C:Byte;
    FS:FillSettingsType;
Begin
  Inherited Show;
  GetFillSettings(FS);
  C:=Graph.GetColor;
  SetFillStyle(FS.Pattern, GetColor(5));
  If Prcnt>0 Then
     Bar(X+Abs(Cnvx)+1, Y+Abs(Cnvx)+1,
         Round(X+(Wdth-2*Abs(Cnvx))*Prcnt/100), Y+Hght-Abs(Cnvx)-1);
  S:=GetString;
  SetColor(GetColor(6));
  OutTextXY(X+(Wdth-2*Abs(Cnvx)-TextWidth(S)) Shr 1,
            Y+(Hght-2*Abs(Cnvx)-TextHeight(S)) Shr 1+4, S);
  SetColor(C);
  SetFillStyle(FS.PAttern, FS.Color);
End;

Function TStatusBar.GetString:String;
Begin
  GetString:='';
End;

Function TStatusBar.GetPalette:PPalette;
Const P:String[Length(CStatusBar)]=CStatusBar;
Begin
  GetPalette:=@P;
End;

Function TStatusBar.GetPercent:Word;
Begin
  GetPercent:=Prcnt;
End;

Procedure TStatusBar.SetPercent(APrcnt:Longint);
Begin
  If APrcnt<>Prcnt Then
     Begin
       Prcnt:=APrcnt;
       Show;
     End;
End;

Constructor TButton.Init(AX1, AY1, AWdth, AHght:Word; ABHght:Integer);
Begin
  Inherited Init(AX1, AY1, aWdth, AHght, Abs(ABHght));
End;

Procedure TButton.Show;
Begin
  Inherited Show;
  If GetPressed Then ShowButtonImage(X+(-1)*Cnvx+2, Y+(-1)*Cnvx+1)
                Else ShowButtonImage(X+Cnvx, Y+Cnvx);
End;

Procedure TButton.Press(APrss:Boolean);
Begin
  If ((APrss)And(Cnvx<0))Or((Not APrss)And(Cnvx>0)) Then Exit;
  Cnvx:=-Cnvx;
End;

Function TButton.GetPressed:Boolean;
Begin
  GetPressed:=(Cnvx<0);
End;

Procedure TButton.ShowButtonImage(IX, IY:Word);
Begin
End;

Constructor TTextButton.Init(AX1, AY1, AWdth, AHght:Word; ABHght:Integer;
                             Const ATitle:String);
Begin
  Inherited Init(AX1, AY1, AWdth, AHght, ABHght);
  Title:=NewStr(ATitle);
End;

Destructor TTextButton.Done;
Begin
  DisposeStr(Title);
  Inherited Done;
End;

Procedure TTextButton.ShowButtonImage(IX, IY:Word);
Var DX, DY:Word;
Begin
  OutTextXY(IX+(Wdth-2*Abs(Cnvx)-TextWidth(Title^)) Shr 1,
            IY+(Hght-2*Abs(Cnvx)-TextHeight(Title^)) Shr 1, Title^);
End;

Function TTextButton.GetPalette:PPalette;
Const P:String[Length(CTextButton)]=CTextButton;
Begin
  GetPalette:=@P;
End;

Function NewStr(Const S:String):PString;
Var P:PString;
Begin
  GetMem(P, Length(S)+1);
  P^:=S;
  NewStr:=P;
End;

Procedure DisposeStr(Var P:PString);
Begin
  FreeMem(P, Length(P^)+1);
  P:=Nil;
End;

END.