Uses App, Drivers, Objects, Views, KursObjs, MyKurs, Dialogs, Menus,
     Validate, CMOSL, Crt, CMOFunc, Graph, Buttons;

Type
    TCMOApp=Object(TApplication)
        Status:Word;
        Procedure InitMenuBar; Virtual;
        Procedure InitStatusLine; Virtual;
        Procedure InitDesktop; Virtual;
        Procedure Run; Virtual;
        function CMOCfgDlg:Word;
    End;

    TParams=Record
       T1Nach, T1Kon, T1Dlt,
       T2Min, T2Max, TApp:String[5];
       List:PStringCollection; Act:Word;
       Delta:String[5];
       TAlphSQR:Real;
    End;

    TPreModelParams=Record
        PMOpt:Word;
        ReqNum, Step, TIst1:String[5];
    End;

Var CMOCfg:TParams;
    CMOCfg2:TPreModelParams;
    W:Word;

Procedure EGAVGADriver; External;
{$L EGAVGA.OBJ}

Procedure TCMOApp.InitMenuBar;
Begin
  MenuBar:=Nil;
End;

Procedure TCMOApp.InitStatusLine;
Var R:TRect;
Begin
  GetExtent(R);
  R.A.Y:=R.B.Y-1;
  StatusLine:=New(PCMOSL, Init(R, Nil));
End;

Procedure TCMOApp.InitDesktop;
Var R:TRect;
Begin
  GetExtent(R);
  Dec(R.B.Y);
  New(Desktop, Init(R));
End;

Procedure TCMOApp.Run;
Begin
  Status:=CMOCfgDlg;
End;

function TCMOApp.CMOCfgDlg:Word;

  Function GetDL:PStringCollection;
  Var D:PStringCollection;
  Begin
    New(D, Init(10, 0));
    D^.Insert(NewStr('0.90  (1.64)'));
    D^.Insert(NewStr('0.85  (2.08)'));
    D^.Insert(NewStr('0.90  (2.71)'));
    D^.Insert(NewStr('0.95  (3.84)'));
    D^.Insert(NewStr('0.96  (4.21)'));
    D^.Insert(NewStr('0.97  (4.49)'));
    D^.Insert(NewStr('0.98  (5.43)'));
    D^.Insert(NewStr('0.99  (6.61)'));
    D^.Insert(NewStr('0.999 (10.9)'));
    GetDL:=D;
  End;

Const
     D:TParams=(T1Nach:'1.0'; T1Kon:'2.0'; T1Dlt:'0.2';
                T2Min:'1.0'; T2Max:'3.0'; TApp:'2.0';
                List:Nil; Act:2; Delta:'0.1');
     D2:TPreModelParams=
        (PMOpt:1; ReqNum:'1150'; Step:'40';TIst1:'');

var
     Control,Control1 : PView;
     R : TRect;
     Dialog : PDialog;
     C:Integer;
begin
   R.Assign(0,0,50,16);
   Dialog := New(PDialog,Init(R,'ࠬ ⥬'));
   with Dialog^ do
    begin
       Options:=Options Or ofCentered;

       R.Assign(4,2,15,3);
       Insert(New(PStaticText, Init(R, ' 1- ')));
       R.Assign(9,3,15,4);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcTNach;
       Insert(Control);
       PInputLine(Control)^.SetValidator(New(PRealValidator, Init));
       R.Assign(3,3,8,4);
       Insert(New(PLabel,Init(R,'T',Control)));

       R.Assign(9,4,15,5);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcTKon;
       Insert(Control);
       PInputLine(Control)^.SetValidator(New(PRealValidator, Init));
       R.Assign(3,4,8,5);
       Insert(New(PLabel,Init(R,'T',Control)));

       R.Assign(9,5,15,6);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcTIzm;
       Insert(Control);
       PInputLine(Control)^.SetValidator(New(PRealValidator, Init));
       R.Assign(3,5,8,6);
       Insert(New(PLabel,Init(R,'T',Control)));

       R.Assign(4,7,15,8);
       Insert(New(PStaticText, Init(R, ' 2- ')));
       R.Assign(9,8,15,9);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcTNach2;
       Insert(Control);
       PInputLine(Control)^.SetValidator(New(PRealValidator, Init));
       R.Assign(3,8,8,9);
       Insert(New(PLabel,Init(R,'Tmin',Control)));

       R.Assign(9,9,15,10);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcTKon2;
       Insert(Control);
       PInputLine(Control)^.SetValidator(New(PRealValidator, Init));
       R.Assign(3,9,8,10);
       Insert(New(PLabel,Init(R,'Tmax',Control)));

       R.Assign(4,11,15,12);
       Insert(New(PStaticText, Init(R, ' ਡ ')));
       R.Assign(9,12,15,13);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcTApp;
       Insert(Control);
       PInputLine(Control)^.SetValidator(New(PRealValidator, Init));
       R.Assign(4,12,8,13);
       Insert(New(PLabel,Init(R,'T',Control)));

       R.Assign(45,3,46,8);
       Control := New(PScrollBar,Init(R));
       Insert(Control);
       R.Assign(19,3,45,8);
       Control := New(PListBox,Init(R,1,PScrollBar(Control)));
       Control^.Options := Control^.Options or ofFramed;
       Control^.HelpCtx := hcVerList;
       Insert(Control);
       D.List:=GetDL;
       R.Assign(19,2,33,3);
       Insert(New(PLabel,Init(R,'. -',Control)));

       R.Assign(30,9,37,10);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcDelta;
       Insert(Control);
       PInputLine(Control)^.SetValidator(New(PRealValidator, Init));
       R.Assign(23,9,29,10);
       Insert(New(PLabel,Init(R,'delta',Control)));

       R.Assign(21,11,44,13);
       Control := New(Dialogs.PButton,Init(R,'ࠬ...',cmOk,bfDefault));
       Control^.HelpCtx := hcModel;
       Insert(Control);

       R.Assign(21,13,44,15);
       Control := New(Dialogs.PButton,Init(R,'室',cmCancel,bfNormal));
       Control^.HelpCtx := hcExit;
       Insert(Control);

       SelectNext(False);
    end;
   Dialog^.SetData(D);
   W := DeskTop^.ExecView(Dialog);
   Dialog^.GetData(D);
   Dispose(Dialog,Done);
   If W=cmCancel Then Exit;

   Val(Copy(String(D.List^.At(D.Act)^), Pos('(', String(D.List^.At(D.Act)^))+1, 4), D.TAlphSQR, C);
   CMOCfg:=D;
   R.Assign(0,0,57,10);
   Dialog := New(PDialog,Init(R,'६஢'));
   with Dialog^ do
    begin
       Options:=Options Or ofCentered;

       R.Assign(5,3,27,6);
       Control := New(PRadioButtons,Init(R,
                  NewSItem(' delta  ??%',
                  NewSItem(' ⢥ত',
                  NewSItem(' ', nil)))));
       Control^.HelpCtx := hcModelOpt;
       Insert(Control);
       R.Assign(5,2,22,3);
       Insert(New(PLabel,Init(R,'६஢',Control)));

       R.Assign(44,3,52,4);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcReqNum;
       PInputLine(Control)^.SetValidator(New(PRangeValidator, Init(100, 5000)));
       Insert(Control);
       R.Assign(30,3,43,4);
       Insert(New(PLabel,Init(R,'᫮ ',Control)));

       R.Assign(44,4,52,5);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcStep;
       PInputLine(Control)^.SetValidator(New(PRangeValidator, Init(10, 500)));
       Insert(Control);
       R.Assign(39,4,43,5);
       Insert(New(PLabel,Init(R,'',Control)));

       R.Assign(44,5,52,6);
       Control := New(PInputLine,Init(R,5));
       Control^.HelpCtx := hcTPreModel;
       Insert(Control);
       PInputLine(Control)^.SetValidator(New(PRealValidator, Init));
       R.Assign(37,5,43,6);
       Insert(New(PLabel,Init(R,'T1',Control)));

       R.Assign(4,7,25,9);
       Control := New(Dialogs.PButton,Init(R,'஢',cmOk,bfDefault));
       Control^.HelpCtx := hcModel2;
       Insert(Control);

       R.Assign(30,7,51,9);
       Control := New(Dialogs.PButton,Init(R,'室',cmCancel,bfNormal));
       Control^.HelpCtx := hcExit;
       Insert(Control);

       SelectNext(False);
    end;
   D2.TIst1:=D.T1Nach;
   Dialog^.SetData(D2);
   W:=DeskTop^.ExecView(Dialog);
   If W=cmOk Then Dialog^.GetData(D2);
   CMOCfg2:=D2;
   Dispose(Dialog,Done)
end;

Type
    TRealArray=Array[0..65520 Div SizeOf(Real)-1]Of Real;

Var CMOApp:TCMOApp;
    Adm:PMyAdministrator;
    I, Maked, J, MC, DatWdth:Word;
    C:Integer;
    Ch:Char;
    LMin, LMax, LD, TMin, TMax, LApp, TAlph:Real;
    RqNum, Stp:Integer;
    Potk:Array[1..2]Of Pointer; Tpreb:Pointer;
    MaxTPreb:Real;
    Delta, L1PM:Real;
    GD, GM:Integer;
    S:String[20];
    ItSB:PStatusBar;
    fl:Boolean;


Begin
 If RegisterBGIDriver(@EGAVGADriver)<0 Then Halt;
 Repeat
  CMOApp.Init;
  CMOApp.Run;
  CMOApp.Done;
  If W=cmCancel Then Halt;
  Val(CMOCfg.T1Nach, LMin, C); Val(CMOCfg.T1Kon, LMax, C); Val(CMOCfg.T1Dlt, LD, C);
  Val(CMOCfg.T2Min, TMin, C); Val(CMOCfg.T2Max, TMax, C);
  Val(CMOCfg.TApp, LApp, C);
  Val(CMOCfg2.Step, Stp, C);
  TAlph:=CMOCfg.TAlphSQR;
  GD:=VGA; GM:=VGAHi;
  InitGraph(GD, GM, '');
  If CMOCfg2.PMOpt<2 Then
     Begin
       Val(CMOCfg.Delta, Delta, C);
       Val(CMOCfg2.TIst1, L1PM, C);
       Adm:=New(PCountRqsAdmin, Init(CMOCfg2.PMOpt, Stp, L1PM, TMin, TMax, LApp, SQRT(TAlph), Delta));
       Adm^.RunSystem;
       If Adm^.Status=StopESC
          Then RqNum:=0 Else RqNum:=Adm^.Gend[1];
       Dispose(Adm, Done);
     End Else Val(CMOCfg2.ReqNum, RqNum, C);
  If RqNum>0 Then
     Begin
       MC:=Trunc((LMax-LMin)/LD+1);
       DatWdth:=500 Div MC;
       For J:=1 To 2 Do GetMem(Potk[J], MC*SizeOf(Real));
       GetMem(Tpreb, MC*SizeOf(Real));
       Randomize;
       ItSB:=New(PGlobalSB, Init(320, 460, 319, 20, 2, MC, RqNum));
       For I:=0 To MC-1 Do
           Begin
             Adm:=New(PModelAdmin, Init(RqNum, Stp, LMin+I*LD, TMin, TMax, LApp, CMOCfg.TAlphSQR, ItSB));
             Adm^.RunSystem;
             If Adm^.Status=StopESC Then Break;
             For J:=1 To 2 Do
                 TRealArray(Potk[J]^)[I]:=Adm^.Failed[J]/Adm^.Gend[J];
             TRealArray(Tpreb^)[I]:=Adm^.TL1/Adm^.Hndl[1];
             Dispose(Adm, Done);
             Inc(PGlobalSB(ItSB)^.Iter);
             fl:=(I=MC-1);
           End;
       If I>0 Then
          Begin
            Maked:=I;
            If fl Then Inc(Maked);
            MaxTPreb:=0;
            For I:=0 To Maked-1 Do
                If TRealArray(Tpreb^)[I]>MaxTPreb Then MaxTPreb:=TRealArray(Tpreb^)[I];
            MaxTPreb:=Trunc(MaxTPreb)+1;
            ClearDevice;
            SetColor(15);
            SetTextStyle(DefaultFont, HorizDir, 1);
            SetLineStyle(SolidLn, 0, 1);
            DrawCoord(50, 150, 503, 140, 't', 'P1');
            DrawCoord(50, 300, 503, 140, 't', 'P2');
            DrawCoord(50, 450, 503, 140, 't', 'Tॡ');
            For I:=0 To Maked-1 Do
                Begin
                  Str((LMin+I*LD):1:2, S);
                  SetColor(12);
                  For J:=1 To 3 Do
                      OutTextXY(50+I*DatWdth+10+(DatWdth-20-TextWidth(S)) Shr 1,
                                150*J+5, S);
                  For J:=1 To 2 Do
                      Begin
                        Str(TRealArray(Potk[J]^)[I]:1:3, S);
                        SetFillStyle(SlashFill+J-1, 9+J);
                        SetColor(9+J);
                        Bar3D(50+I*DatWdth+10, Round(150*J-100*TRealArray(Potk[J]^)[I]),
                              50+(I+1)*DatWdth-10, 150*J-1, 8, True);
                        OutTextXY(50+I*DatWdth+10+(DatWdth-20-TextWidth(S)) Shr 1,
                                  Round(150*J-100*TRealArray(Potk[J]^)[I]-15), S);
                      End;
                  Str(TRealArray(TPreb^)[I]:1:3, S);
                  SetFillStyle(HatchFill, 14);
                  SetColor(14);
                  Bar3D(50+I*DatWdth+10, Round(450-100*TRealArray(TPreb^)[I]/MaxTPreb),
                        50+(I+1)*DatWdth-10, 449, 8, True);
                  OutTextXY(50+I*DatWdth+10+(DatWdth-20-TextWidth(S)) Shr 1,
                            Round(450-100*TRealArray(TPreb^)[I]/MaxTPreb-15), S);
                End;
           ReadKey;
         End;
       For J:=1 To 2 Do FreeMem(Potk[J], MC*SizeOf(Real));
       FreeMem(Tpreb, MC*SizeOf(Real));
       CloseGraph;
     End;
 Until False;
End.