Unit CMOSL;

Interface

Uses Menus, Validate, MsgBox;

Const
     hcTNach            = 1000;
     hcTKon             = 1001;
     hcTIzm             = 1002;
     hcTNach2           = 1003;
     hcTKon2            = 1004;
     hcTApp             = 1005;
     hcModelStep        = 1006;
     hcVerList          = 1007;
     hcDelta            = 1008;
     hcModel            = 1010;
     hcExit             = 1011;

     hcModelOpt         = 1020;
     hcReqNum           = 1024;
     hcStep             = 1025;
     hcTPreModel        = 1026;
     hcModel2           = 1028;

Type
    PCMOSL=^TCMOSL;
    TCMOSL=Object(TStatusLine)
       Function Hint(H:Word):String; Virtual;
    End;

    PRealValidator=^TRealValidator;
    TRealValidator=Object(TFilterValidator)
         Constructor Init;
         procedure Error; virtual;
         function IsValid(const S: string): Boolean; virtual;
         function IsValidInput(var S: string; SuppressFill: Boolean): Boolean; virtual;
    End;

Implementation

{* TRealValidator *}
Constructor TRealValidator.Init;
Begin
  Inherited Init(['0'..'9','.']);
End;

procedure TRealValidator.Error;
Begin
  MessageBox('訡 ', Nil, mfError+mfOkButton);
End;

function TRealValidator.IsValid(const S: string): Boolean;
Var C:Integer;
    R:Real;
Begin
  Val(S, R, C);
  IsValid:=(C=0);
End;

function TRealValidator.IsValidInput(var S:string; SuppressFill: Boolean): Boolean;
Var C:Integer;
    R:Real;
Begin
  Val(S, R, C);
  IsValidInput:=(S='')Or(C=0);
End;


{* TCMOSL *}
Function TCMOSL.Hint(H:Word):String;
Begin
  Case H Of
    hcTNach:Hint:='砫쭮 ६ ஢ ࢮ 筨';
     hcTKon:Hint:='筮 ६ ஢ ࢮ 筨';
     hcTIzm:Hint:=' ६ ஢ ࢮ 筨';
   hcTNach2:Hint:='쭮 ६ ஢ ண 筨';
    hcTKon2:Hint:='ᨬ쭮 ६ ஢ ண 筨';
     hcTApp:Hint:='६ ࠡ ';
  hcVerList:Hint:='⥫쭠 ⭮';
hcModelStep:Hint:=' ⮡ࠦ ଠ樨';
    hcDelta:Hint:='⭮⥫쭠 譮 ७';
    hcModel:Hint:='ந ࠬ ६஢';
  hcModelOpt:Hint:='஢ ६஢  ⠭  delta   祭';
hcModelOpt+1:Hint:='⢥ত த ६஢  ।.蠣 ( - )';
hcModelOpt+2:Hint:=' ᮢ ६஢ (室  ᫮ )';
   hcReqNum:Hint:='᫮  "᪠"  ⥬';
     hcStep:Hint:=' ⮡ࠦ ଠ樨';
hcTPreModel:Hint:='६ ࠡ ࢮ 筨   ६஢';
   hcModel2:Hint:='ந ஢';
     hcExit:Hint:='室  ';
    Else Hint:='';
  End;
End;

END.