Unit KursObjs;

Interface

Const
    dtUnknown           = $FFFF;
    dtSourcer           = 1;
    dtBuffer            = 2;
    dtApparat           = 3;

Type
    TTime        = Real;
    TRequest=Record {  }
             TimeLive:TTime; { ६  }
             Sourcer:Word; { 筨  }
    End;

    PDevice=^TDevice;  { ࠪ⭮ ன⢮ }
    TDevice=Object
            Next:PDevice;    { .  ᯨ᪥ ன }
            NextEvent:TTime; { ६ १ . ன⢮ 樨 ᮡ⨥ }
                             { -1 ᫨  㦭 }
            Constructor Init;   { 樠 ன⢠ }
            Destructor Done; Virtual; { 襭 ன⢠ }
            Procedure GetRequest(Var Rq:TRequest); Virtual; {   }
                                                            {  ன⢠ }
            Procedure PutRequest(Var Rq:TRequest); Virtual; { ࠢ  }
                                                            {  ன⢮ }
            Function DeviceType:Word; Virtual; {  ன⢠ (dtXXXX) }
            Procedure ChangeTime(DT:TTime); Virtual; { 뢠  }
                                                     {  ६  ⥬ }
    End;

    PSourcer=^TSourcer;  { ࠪ 筨 }
    TSourcer=Object(TDevice)
            Name:Word;   {  筨 }
            Constructor Init(AName:Word); { 樠. AName -  }
            Procedure GetRequest(Var Rq:TRequest); Virtual; { 頥  }
                                     {  뢠 NextEventTime  樨 }
                                     { ६  ᫥饩  }
            Function DeviceType:Word; Virtual; { 頥 dtSourcer }
            Procedure NextEventTime; Virtual; {  ६ 樨 }
                                              { ᫥.  }
    End;

    PBuffer=^TBuffer;   { ࠪ  }
    TBuffer=Object(TDevice)
            Buffer:Pointer;   {  }
            Size, FreeSize:Integer; {   ᫮ ᢮    }
            Constructor Init(ASize:Word); { 樠. ASize - ᫮    }
            Destructor Done; Virtual;
            Procedure GetRequest(Var Rq:TRequest); Virtual;
                      { "᪨"   , 뢠 RemoveFromBuffer }
            Procedure PutRequest(Var Rq:TRequest); Virtual;
                      { 頥   , 뢠 AddToBuffer }
                      { ᫨  ⮬     ,    }
                      { "롨" 㣠,  頥  楤 }
            Function DeviceType:Word; Virtual; { 頥 dtBuffer }
            Procedure ChangeTime(DT:TTime); Virtual;
                      {  ६       DT }
            Procedure AddToBuffer(Var Rq:TRequest); Virtual;
                      {     (.. ४) }
            Procedure RemoveFromBuffer(Var Rq:TRequest); Virtual;
                      {     (.. ४) }
    End;

    PApparat=^TApparat; { ࠪ ਡ }
    TApparat=Object(TDevice)
            Constructor Init;
            Procedure PutRequest(Var Rq:TRequest); Virtual;
                      { 頥   ࠡ, 뢠 NextEventTime }
                      {  ᫥ ६ ࠡ⪨ }
            Function DeviceType:Word; Virtual; { 頥 dtApparat }
            Procedure NextEventTime; Virtual;
                      {  ६ ࠡ⪨  }
            Procedure ChangeTime(DT:TTime); Virtual;
    End;

    PAdministrator=^TAdministrator; {  ⥬ ஢ }
    TAdministrator=Object
            DeviceList:PDevice; { ᮪  ன (筨,  ਡ) }
            Constructor Init; { 뢠 InitAdministrator  ஥ ᯨ᪠ }
                              { ன }
            Destructor Done; Virtual; { 蠥 ᯨ᮪ ன }
            Procedure InitAdministrator; Virtual;
                      {   ४  ⮬ }
                      {  ᯨ᮪ ன ⥬ }
            Procedure AddDevice(P:PDevice);
                      {  ன⢮ P  ᯨ }
            Procedure RunSystem;
                      { ᪠ ⥬  ஢, .. }
                      {  樨, ࠡ⪨ ,  饭, }
                      { 祭   }
            Procedure ChangeTime(DT:TTime);
                      {  ६  ⥬, 뢠 ChangeTime }
                      {  ன }

            Function CanContinue:Boolean; Virtual;
                     {   True, ᫨ 室 த }
                     { ஢,  False }
            Procedure RequestGenerated(Var Rq:TRequest); Virtual;
                      { 뢠 ᫥ 樨  Rq }
            Procedure RequestFailed(Var Rq:TRequest); Virtual;
                      { 뢠 ᫥ ⪠  Rq  }
                      { 饭   }
            Procedure RequestHandled(Var Rq:TRequest); Virtual;
                      { 뢠  ࠡ⪥  Rq }
            Procedure ShowAdministrator; Virtual;
                      { 뢠 ﭨ ⥬ }
    End;

Implementation

{* TDevice *}
Constructor TDevice.Init;
Begin
  Next:=Nil;
  NextEvent:=-1;
End;

Destructor TDevice.Done;
Begin
End;

Procedure TDevice.GetRequest(Var Rq:TRequest);
Begin
End;

Procedure TDevice.PutRequest(Var Rq:TRequest);
Begin
End;

Function TDevice.DeviceType:Word;
Begin
  DeviceType:=dtUnknown;
End;

Procedure TDevice.ChangeTime(DT:TTime);
Begin
  If NextEvent<>-1 Then
     NextEvent:=NextEvent-DT;
End;


{* TSourcer *}
Constructor TSourcer.Init(AName:Word);
Begin
  Inherited Init;
  Name:=AName;
  NextEventTime;
End;

Procedure TSourcer.GetRequest(Var Rq:TRequest);
Begin
  Rq.Sourcer:=Name;
  Rq.TimeLive:=0;
  NextEventTime;
End;

Function TSourcer.DeviceType:Word;
Begin
  DeviceType:=dtSourcer;
End;

Procedure TSourcer.NextEventTime;
Begin
End;

{* TBuffer *}
Constructor TBuffer.Init(ASize:Word);
Begin
  Inherited Init;
  GetMem(Buffer, ASize*SizeOf(TRequest));
  FillChar(Buffer^, ASize*SizeOf(TRequest), 0);
  Size:=ASize;
  FreeSize:=Size;
End;

Destructor TBuffer.Done;
Begin
  FreeMem(Buffer, Size*SizeOf(TRequest));
  Inherited Done;
End;

Procedure TBuffer.GetRequest(Var Rq:TRequest);
Begin
  Rq.Sourcer:=$FFFF;
  If FreeSize=Size Then Exit;
  RemoveFromBuffer(Rq);
  Inc(FreeSize);
End;

Procedure TBuffer.PutRequest(Var Rq:TRequest);
Begin
  AddToBuffer(Rq);
  If FreeSize>0 Then Dec(FreeSize);
End;

Function TBuffer.DeviceType:Word;
Begin
  DeviceType:=dtBuffer;
End;

Procedure TBuffer.ChangeTime(DT:TTime);
Type BufferList=Array[0..65520 Div SizeOf(TRequest)]Of TRequest;
Var I:Longint;
Begin
  Inherited ChangeTime(DT);
  If Size-FreeSize=0 Then Exit;
  For I:=0 To Size-FreeSize-1 Do
      BufferList(Buffer^)[I].TimeLive:=BufferList(Buffer^)[I].TimeLive+DT;
End;

Procedure TBuffer.AddToBuffer(Var Rq:TRequest);
Begin
End;

Procedure TBuffer.RemoveFromBuffer(Var Rq:TRequest);
Begin
End;

{* TApparat *}
Constructor TApparat.Init;
Begin
  Inherited Init;
{  NextEventTime;}
  NextEvent:=0;
End;

Procedure TApparat.PutRequest(Var Rq:TRequest);
Begin
  NextEventTime;
  Rq.TimeLive:=Rq.TimeLive+NextEvent;
End;

Function TApparat.DeviceType:Word;
Begin
  DeviceType:=dtApparat;
End;

Procedure TApparat.NextEventTime;
Begin
End;

Procedure TApparat.ChangeTime(DT:TTime);
Begin
  If NextEvent>0 Then Inherited ChangeTime(DT);
End;

{* TAdministrator *}
Constructor TAdministrator.Init;
Begin
  DeviceList:=Nil;
  InitAdministrator;
End;

Destructor TAdministrator.Done;
Var P:PDevice;
Begin
  While DeviceList<>Nil Do
        Begin
          P:=DeviceList;
          DeviceList:=DeviceList^.Next;
          Dispose(P, Done);
        End;
End;

Procedure TAdministrator.AddDevice(P:PDevice);
Begin
  P^.Next:=DeviceList;
  DeviceList:=P;
End;

Procedure TAdministrator.RunSystem;
Var P, PN:PDevice;
    Rqs:TRequest;
    Dt:Word;
    Buf:PBuffer;
    TMin:TTime;
Begin
  P:=DeviceList;
  While (P^.DeviceType<>dtBuffer)And(P<>Nil) Do
        P:=P^.Next;
  If P=Nil Then Exit;
  Buf:=PBuffer(P);
  While CanContinue Do
        Begin
          ShowAdministrator;
          P:=DeviceList;
          TMin:=1E+10;
          PN:=Nil;
          While P<>Nil Do
                Begin
                  If (P^.NextEvent<>-1)And(P^.NextEvent<TMin) Then
                     If ((P^.DeviceType=dtApparat)And((Buf^.FreeSize<Buf^.Size)Or(P^.NextEvent>0)))
                        Or (P^.DeviceType<>dtApparat) Then
                        Begin
                          PN:=P; TMin:=P^.NextEvent;
                        End;
                  P:=P^.Next;
                End;
          ChangeTime(TMin);
          Dt:=PN^.DeviceType;
          Case Dt Of
               dtSourcer:Begin
                           PN^.GetRequest(Rqs);
                           RequestGenerated(Rqs);
                           Buf^.PutRequest(Rqs);
                           If Rqs.Sourcer<>0 Then
                              RequestFailed(Rqs);
                         End;
               dtApparat:Begin
                           Buf^.GetRequest(Rqs);
                           If Rqs.Sourcer<>$FFFF Then
                              Begin
                                PN^.PutRequest(Rqs);
                                RequestHandled(Rqs);
                              End;
                         End;
          End;
        End;
End;

Procedure TAdministrator.ChangeTime(DT:TTime);
Var P:PDevice;
Begin
  P:=DeviceList;
  While P<>Nil Do
        Begin
          P^.ChangeTime(DT);
          P:=P^.Next;
        End;
End;

Procedure TAdministrator.InitAdministrator;
Begin
End;

Function TAdministrator.CanContinue:Boolean;
Begin
  CanContinue:=False;
End;

Procedure TAdministrator.RequestGenerated(Var Rq:TRequest);
Begin
End;

Procedure TAdministrator.RequestFailed(Var Rq:TRequest);
Begin
End;

Procedure TAdministrator.RequestHandled(Var Rq:TRequest);
Begin
End;

Procedure TAdministrator.ShowAdministrator;
Begin
End;

END.