Unit TVPart;

Interface

Uses App, Menus;

Const
     hcPlainHght        = 1000;
     hcGroundHght       = 1001;
     hcGunPos           = 1002;
     hcOk               = 1003;
     hcExit             = 1004;

Type
    PSSL=^TSSL;
    TSSL=Object(TStatusLine)
         Function Hint(HC:Word):String; Virtual;
    End;

    TShootApp=Object(TApplication)
          Procedure InitMenuBar; Virtual;
          Procedure InitDesktop; Virtual;
          Procedure InitStatusLine; Virtual;
          Procedure Run; Virtual;
    End;

Var Status:Word;
    PlainHght, GunPos, GrndHght:Integer;

Implementation

Uses Dialogs, Objects, Views, Drivers, Validate;

Type
    TData=Record
      PH, GH, GP:String[4];
    End;

Const
     D:TData=(PH:'400';GH:'30';GP:'0');

Function TSSL.Hint(HC:Word):String;
Begin
  Case HC Of
  hcPlainHght:Hint:='Plain''s fly height (250 - 420)';
 hcGroundHght:Hint:='Ground height (0 - 100)';
     hcGunPos:Hint:='Gun position on the ground (-300 - 300)';
         hcOk:Hint:='Run game with entered parameters';
       hcExit:Hint:='Exit the game';
      Else Hint:='';
  End;
End;

Procedure TShootApp.InitMenuBar;
Begin
  MenuBar:=Nil;
End;

Procedure TShootApp.InitDesktop;
Var R:TRect;
Begin
  GetExtent(R);
  Dec(R.B.Y);
  New(Desktop, Init(R));
End;

Procedure TShootApp.InitStatusLine;
Var R:TRect;
Begin
  GetExtent(R);
  R.A.Y:=R.B.Y-1;
  StatusLine:=New(PSSL, Init(R,
     NewStatusDef(0, $FFFF,
        NewStatusKey('~Alt+X~ Exit', kbAltX, cmCancel,
        Nil),
        Nil)));
End;

Procedure GetParams;
var
     Control,Control1 : PView;
     R : TRect;
     Dialog : PDialog;
     W:Word;
begin
   R.Assign(0,0,30,11);
   Dialog := New(PDialog,Init(R,'Game parameters'));
   with Dialog^ do
    begin
       Options:=Options Or ofCentered;

       R.Assign(18,2,24,3);
       Control := New(PInputLine,Init(R,4));
       Control^.HelpCtx := hcPlainHght;
       PInputLine(Control)^.SetValidator(New(PRangeValidator, Init(250, 420)));
       Insert(Control);
       R.Assign(4,2,18,3);
       Insert(New(PLabel,Init(R,'~P~lain height',Control)));

       R.Assign(19,4,25,5);
       Control := New(PInputLine,Init(R,4));
       Control^.HelpCtx := hcGroundHght;
       PInputLine(Control)^.SetValidator(New(PRangeValidator, Init(0, 100)));
       Insert(Control);
       R.Assign(4,4,19,5);
       Insert(New(PLabel,Init(R,'~G~round height',Control)));

       R.Assign(18,6,24,7);
       Control := New(PInputLine,Init(R,4));
       Control^.HelpCtx := hcGunPos;
       PInputLine(Control)^.SetValidator(New(PRangeValidator, Init(-300, 300)));
       Insert(Control);
       R.Assign(4,6,18,7);
       Insert(New(PLabel,Init(R,'G~u~n position',Control)));

       R.Assign(4,8,14,10);
       Control := New(PButton,Init(R,'~O~k',cmOk,bfDefault));
       Control^.HelpCtx := hcOk;
       Insert(Control);

       R.Assign(16,8,26,10);
       Control := New(PButton,Init(R,'E~x~it',cmCancel,bfNormal));
       Control^.HelpCtx := hcExit;
       Insert(Control);

       SelectNext(False);
    end;
   Dialog^.SetData(D);
   W := DeskTop^.ExecView(Dialog);
   Dialog^.GetData(D);
   Dispose(Dialog,Done);
   Status:=W;
end;

Procedure TShootApp.Run;
Var C:Integer;
Begin
  GetParams;
  Val(D.PH, PlainHght, C);
  Val(D.GP, GunPos, C);
  Val(D.GH, GrndHght, C);
End;

END.